import 'package:get/get.dart';

class RxModel<T> extends Rx<T> {
  Future<T> Function() source;

  RxModel({
    required this.source,
    required T defaultValue,
    bool autoStart = true,
  }) : super(defaultValue) {
    if (autoStart) {
      fetch();
    }
  }

  Future fetch() async {
    await source().then((data) => this.value = data);
  }
}
